Procedure ShowPic (Mode : FromMode; Encoding, X, Y, Gd : Integer;
  SetPalette : Boolean; PutMode : Word; Var Header : PcxHeader);
Type
  ImageMem = Record
    X, Y : Integer;
    Mem  : Array [0..0] of Byte
  End;
  PImageMem = ^ImageMem;
Var Divisor, BytesPerLine, ImgSize, PixelsPerLine, JJ : Word;
    I, J, L                                           : Integer;
    P                                                 : Pointer;
    PI                                                : PImageMem;
    Screen                                            : Integer;
Begin
  Case Gd of
    EGA, VGA  : Screen := 0;
    HercMono  : Screen := 1;
    CGA       : Screen := 2;
    else        Screen := -Gd
  End;
  If (SetPalette and (Header.Version in [2, 5]))
    Then SetPcxPalette (Screen, Header.Palette);
  If Encoding = 1
    Then Begin
      ReadByte := ReadPcxByte;
      ReadMemoryByte := GetByteFromMemory
    End
    Else Begin
      ReadByte := ReadNonCompressedByte;
      ReadMemoryByte := GetNonCompressedByteFromMemory
    End;
  Divisor := 8 div Header.Bits;
  PixelsPerLine := Header.Xmax - Header.Xmin + 1;
  BytesPerLine := PixelsPerLine div Divisor;
  If (PixelsPerLine mod Divisor) <> 0
    Then Inc (BytesPerLine);
  ImgSize := ImageSize (Header.Xmin, 0, Header.Xmax, 0);
  GetMem (PI, ImgSize);
  PI^.X := PixelsPerLine - 1;
  PI^.Y := 0;
  For L := Y To Header.Ymax - Header.Ymin Do
    Begin
      For J := Header.Planes - 1 DownTo 0 Do
        Begin
          JJ := J * BytesPerLine;
          If Mode = FromFile
            Then Begin
              For I := 0 To BytesPerLine - 1 Do
                PI^.mem [I + JJ] := ReadByte;
              If BytesPerLine <> Header.BytesPerLine
                Then ReadByte
            End
            Else Begin
              For I := 0 To BytesPerLine - 1 Do
                PI^.mem [I + JJ] := ReadMemoryByte;
              If BytesPerLine <> Header.BytesPerLine
                Then ReadMemoryByte
            End
        End;
      PutImage (X, L, PI^, PutMode)
    End;
  FreeMem (PI, ImgSize)
End;
